PeopleSoft Anypoint&trade; Studio Connector Demo
================================================

## Introduction

The current demo application provides a complete workflow to invoke PeopleSoft's standard operations sequentially given the Component Interface (CI) **CI_PERSONAL_DATA**, which is part of HCM module and handles the Personal Information of Employees. 

## Prerequisites

* Java 7
* Mule Runtime 3.7.0 EE or higher
* DataWeave
* PeopleSoft Java Object Library (psjoa.jar)
* Access to a PeopleSoft instance
* One (or more) Component Interfaces configured, with all permissions granted.

## Import the project

* Go to **File > Import**
* Select **Anypoint Studio Project from External Location** (under the parent folder "Anypoint Studio")

![Menu](images/ps-import-menu.png)

* Provide the root path to the demo project folder.
* Select Mule Runtime (3.7.x EE).

![File Selection](images/ps-import-file.png)

* Click **Finish**.  
* Set PeopleSoft credentials inside the file `src/main/resources/peoplesoft.properties`.

```
config.server=<HOST:PORT>
config.username=<USERNAME>
config.password=<PASSWORD>
config.domainConnectionPwd=<PASSWORD>
config.componentInterfaceIdsWhiteList=<CI_NAME_1,CI_NAME_2,CI_NAME_N> (e.g. CI_PERSONAL_DATA)
```
* Inside the Global Elements view, double-click the PeopleSoft Configuration component and click "Test Connection". A successful message should pop-up.
![Test Connection](images/ps-config.png)

* Select **Run as Mule Application**.

* Open a browser and access the URL `http://localhost:8081`. You should see the demo application deployed:

![Workflow Demo](images/ps-import-demo.png)
	
## About the flows

**1. Create_Employee_Flow:** creates a new Employee record, populating its attributes with default values. Then, the component is modified with a few more values provided in the HTMl form and finally persisted in the PeopleSoft database by calling the **Save** operation.

![Flow Create](images/ps-flow-create.png)

**2. Find_Employee_Flow:** performs a search and retrieves one or more Employee records, if they match the given parameters. Otherwise, it displays all records (300 maximum), if any.

![Flow Find](images/ps-flow-find.png)

**3. Get_Employee_Flow:** retrieves the complete information of a single Employee record.

![Flow Get](images/ps-flow-get.png)

**4. Save_Employee_Flow:** updates the fields of a single Employee Personal Data record by invoking the Save operation of CI_PERSONAL_DATA Component Interface.

![Flow 4 Save](images/ps-flow-save.png)

## Run the demo

#### Create 
* Click the link **"Create"**.
* Fill in the required fields.
* Click the **"Create record"** button and wait until the operation finishes processing.
* A pop-up message will indicate if the operation was successful or not.

![Demo Create](images/ps-ui-create.png)

#### Find 

* Click the link **"Find"**.
* Fill in the fields.

> While all the parameters are optional, it is advisable that you define as many as possible to narrow the search, especially the Employee ID. If no parameters are defined, the connector will retrieve up to 300 records, if available.

* Click the **"Fetch records"** button.
* Once the operation finishes processing, a list of records will be displayed inside the **Get** form.

![Demo Find](images/ps-ui-find.png)

#### Get 

* Select one of the options available.
* Click the **Fetch record data** button and wait until the operation finishes processing.
* If the operation went successful, some of the Employee attributes will be displayed in the **Save** form.

![Demo Get](images/ps-ui-get.png)

#### Save 

* Modify some or all of the fields.
* Click the **Update record** button and wait until the operation finishes processing.
* To verify that the record was successfully updated, you can perform **Find** operation to see the changes.

![Demo Save](images/ps-ui-save.png)
